<?

$version = "0.5";

function finddot($name, $cssdots, $defaultdot) {
    foreach($cssdots as $x) {
        list($filename, , $width, $height) = split(":", $x);
	if($filename == $name) { $found = 1; $return = array($name, $width, $height); }
	}
if(isset($found)) {
return $return;
} else {
$dott = $cssdots[$defaultdot];
list($dott, , $width, $height) = split(":", $dott);
return array($dott, $width, $height);
}
}

function getlocationcoords($lat, $lon, $width, $height) {
	// some cartographers weren't mathematicians, up is apparently negative to them
    	$lat = ($lat * -1);

	$lat = ($lat + 90);
	$lon = ($lon + 180);
	$x = ($lon * ($width / 360));
	$y = ($lat * ($height / 180));

	$x = round($x);
	$y = round($y);
	return array($x, $y);
}

function getimagecoords($earthimages, $image) {
    foreach($earthimages as $x) {
	list($file, , $width, $height) = split(":", $x);
 	if($file == $image) {
	    $coords = array("$width", "$height");
	    return $coords;
	}
    }
}

function validcookie($cookie) {
    if(preg_match("/.*.:.*.:.*.:.*.:.*./", $cookie)) {
       return TRUE;
    } else {
       return FALSE;
    }
}

function isvalidimage($cookie, $earthimages, $defaultimage) {
#   list(, , , $setearthimage) = split(":", $cookie);
    $setearthimage = $cookie;
       if(isset($setearthimage)) {
           // check if the image is one actually defined, not a cookie edit
	   foreach($earthimages as $image) {
	       list($testearthimage, , , ) = split(":", $image);
	       if($testearthimage == $setearthimage) {
	           $found = 1;
	       }
	   }
	   if(isset($found)) {
               return $setearthimage;
	   } else {
	       return $earthimages[$defaultimage];
	   }
       } else {
           return $earthimages[$defaultimage];
       }
}



function istheregd() {
	if (imagetypes() & IMG_PNG) {
  	 	 return TRUE;
	} else {
   		 return FALSE;
	}
}

function checkbrowser($agent) {
	if (strstr($agent, "Mozilla/4.7")) {
  	 	 return FALSE;
	} else {
   		 return TRUE;
	}
}

function shouldrun($agent) {
if(checkbrowser($agent) && istheregd()) {
return TRUE;
} elseif(!checkbrowser($agent)) {
return FALSE;
} elseif (!istheregd()) {
return FALSE;
}
}

function s10_validate_ip($in) {
  if (is_string($in) && ereg('^([0-9]{1,3})\.([0-9]{1,3})\.' .
                             '([0-9]{1,3})\.([0-9]{1,3})$' ,
                            $in, $part)) {
     if ($part[1] <= 255 && $part[2] <= 255 &&
         $part[3] <= 255 && $part[4] <= 255)
         return TRUE;
  }
  return FALSE;
 }

function getstuff($address, $local) {

# some people still think that urls are hostnames
$address = str_replace("http://", "", $address);
$address = preg_replace("/\/.*$/", "", $address);

// Security checks
$address = escapeshellcmd($address);

$values = array();

$values["address"] = $address;

if(eregi("[a-z]", $address)){
$ipaddress = gethostbyname($address);

$values["hostname"] = $address;

$values["ishost"] = "yes";

} else {

if(s10_validate_ip($address)) {
$values["hostname"] = @gethostbyaddr($address);
$ipaddress = $address;
} else {
$values["validity"] = "no";
}

}

$values["ipaddress"] = $ipaddress;

if(s10_validate_ip($ipaddress)) {
   $stuff = file("http://netgeo.caida.org/perl/netgeo.cgi?target=$ipaddress");
} else { 
$values["validity"] = "no";
 }

if(!isset($values["validity"])) {
// no yes value, so if its set, it's "no"
// skip the entire code block because ip is invalid

$count = 0;
foreach($stuff as $x) {
$stuff[$count] = ucwords(strtolower(trim(substr(substr($x, 15), 0, -5))));
$count++;
}

$values["city"] = $stuff[8];
$values["state"] = $stuff[9];
$values["country"] = $stuff[10];

$values["lat"] = $stuff[11];
$values["lon"] = $stuff[12];

$desc = "";

// check if it is the user's ip address
if($local == 1) { $desc .= "(You) at "; }

// add the ip address and hostname
$desc .= "<b>$values[hostname]</b> (<b>$values[ipaddress]</b>) ";

// use "are" if it is the user's ip address
if($local == 1) { $desc .= "are"; } else { $desc .= "is"; }

$desc .= " located in ";

// add the city if it's there
if($values["city"]) {
$desc .= "$values[city], ";
}

// add the state if its there
if($values["state"]) {
$desc .= "$values[state], ";
}

if($values["country"]) {
// make the country code capital so its ready for lookup
$values["country"] = strtoupper($values["country"]);
// convert the country code to a country name
$countries = file("countries.txt");
$precountry = array_values(preg_grep("/$values[country]  /", $countries));
$values["country"] = trim(substr($precountry[0], 4));
$desc .= "$values[country].";
}

// decide if address can't resolve, be located, or if it's fine
if($values["lat"] == "0.00" && $values["lon"] == "0.00") {
$values["desc"] = "<b>$values[address]</b> cannot be located.";
$values["lat"] = "";
$values["lon"] = "";
} elseif($values["lat"] == "" && $values["lon"] == "") {
$values["desc"] = "<b>$values[address]</b> cannot be resolved.";
} else {
$values["desc"] = $desc;
}

} else {

// check if it was a host before and decide on an error message

if(isset($values["ishost"])) {
$values["desc"] = "<b>$address</b> does not resolve.";
} else {
$values["desc"] = "<b>$address</b> is not a valid IP Address.";
}

// some blank lat/lon for the image script or it will plot us in the center
$values["lon"] = "";
$values["lat"] = "";

}

return($values);
}

?>
